"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var uuid_1 = require("uuid");
var date_fns_1 = require("date-fns");
var useMessaging = function (_a) {
    var original_messages = _a.original_messages, fields = _a.fields, getUser = _a.getUser;
    var _b = react_1.useState([]), messages = _b[0], setMessages = _b[1];
    react_1.useEffect(function () {
        convert();
    }, [original_messages]);
    var firstMessageOfDay = function (index) {
        return index === 0 || !(original_messages[index][fields.date].getFullYear() === original_messages[index - 1][fields.date].getFullYear() &&
            original_messages[index][fields.date].getMonth() === original_messages[index - 1][fields.date].getMonth() &&
            original_messages[index][fields.date].getDate() === original_messages[index - 1][fields.date].getDate());
    };
    var convert = function () { return __awaiter(void 0, void 0, void 0, function () {
        var _messages, _i, original_messages_1, original_message, message;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _messages = [];
                    _i = 0, original_messages_1 = original_messages;
                    _a.label = 1;
                case 1:
                    if (!(_i < original_messages_1.length)) return [3 /*break*/, 4];
                    original_message = original_messages_1[_i];
                    if (firstMessageOfDay(original_messages.indexOf(original_message))) {
                        _messages.push({
                            _id: uuid_1.v4(),
                            text: 'date_message',
                            date: date_fns_1.subMinutes(original_message[fields.date], 1),
                            user: {
                                _id: uuid_1.v4(),
                            },
                            type: 'system'
                        });
                    }
                    return [4 /*yield*/, convert_message(original_message)];
                case 2:
                    message = _a.sent();
                    _messages.push(message);
                    _a.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4:
                    setMessages(_messages);
                    return [2 /*return*/];
            }
        });
    }); };
    var convert_message = function (original_message) { return __awaiter(void 0, void 0, void 0, function () {
        var user, userTask, media, mediaTask;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    userTask = getUser(original_message, fields.user);
                    if (!('then' in userTask)) return [3 /*break*/, 2];
                    return [4 /*yield*/, userTask];
                case 1:
                    user = _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    user = userTask;
                    _a.label = 3;
                case 3:
                    if (!(original_message[fields.type] !== 'text')) return [3 /*break*/, 7];
                    if (!(typeof fields.media === 'string')) return [3 /*break*/, 4];
                    media = original_message[fields.media];
                    return [3 /*break*/, 7];
                case 4:
                    mediaTask = fields.media(original_message);
                    if (!(typeof mediaTask === 'object')) return [3 /*break*/, 6];
                    return [4 /*yield*/, mediaTask];
                case 5:
                    media = _a.sent();
                    return [3 /*break*/, 7];
                case 6:
                    media = mediaTask;
                    _a.label = 7;
                case 7: return [2 /*return*/, {
                        _id: fields.id ? original_message[fields.id] : uuid_1.v4(),
                        text: original_message[fields.text],
                        date: original_message[fields.date],
                        user: user,
                        original: original_message,
                        type: original_message[fields.type],
                        media: media
                    }];
            }
        });
    }); };
    return {
        messages: messages
    };
};
exports.useMessaging = useMessaging;
//# sourceMappingURL=messaging.js.map